diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/t-crtstuff gcc-2.95.3/gcc/config/m68k/t-crtstuff
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/t-crtstuff	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/m68k/t-crtstuff	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,11 @@
+# from ../t-svr4
+EXTRA_PARTS=crtbegin.o crtend.o crti.o crtn.o
+
+# Add flags here as required.
+CRTSTUFF_T_CFLAGS =
+
+# Assemble startup files.
+crti.o: $(srcdir)/config/m68k/crti.s $(GCC_PASSES)
+	$(GCC_FOR_TARGET) -c -o crti.o $(srcdir)/config/m68k/crti.s
+crtn.o: $(srcdir)/config/m68k/crtn.s $(GCC_PASSES)
+	$(GCC_FOR_TARGET) -c -o crtn.o $(srcdir)/config/m68k/crtn.s
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/t-m68kelf gcc-2.95.3/gcc/config/m68k/t-m68kelf
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/m68k/t-m68kelf	Wed Dec 16 15:07:30 1998
+++ gcc-2.95.3/gcc/config/m68k/t-m68kelf	Fri Jun 22 10:49:58 2001
@@ -20,6 +20,8 @@
 MULTILIB_MATCHES = m68000=mc68000 m68000=m68302 mcpu32=m68332 m68020=mc68020 m68020=m68040 m68020=m68060
 MULTILIB_EXCEPTIONS = m68000/msoft-float m5200/m68881 m5200/msoft-float mcpu32/m68881 mcpu32/msoft-float
 
+EXTRA_MULTILIB_PARTS = crtbegin.o crtend.o
+
 LIBGCC = stmp-multilib
 INSTALL_LIBGCC = install-multilib
 
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/mips/rtems.h gcc-2.95.3/gcc/config/mips/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/mips/rtems.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/mips/rtems.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,34 @@
+/* Definitions for rtems targeting a MIPS using ELF.
+   Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* Specify predefined symbols in preprocessor.  */
+
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "-Dmips -DMIPSEB -D_mips -D_MIPSEB \
+   -Drtems -D__rtems__ -Asystem(rtems)"
+
+/* Generate calls to memcpy, memcmp and memset.  */
+#ifndef TARGET_MEM_FUNCTIONS
+#define TARGET_MEM_FUNCTIONS
+#endif
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/mips/rtems64.h gcc-2.95.3/gcc/config/mips/rtems64.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/mips/rtems64.h	Wed Apr 14 05:46:47 1999
+++ gcc-2.95.3/gcc/config/mips/rtems64.h	Fri Jun 22 10:49:58 2001
@@ -61,3 +61,6 @@
 #undef ENDFILE_SPEC
 
 /*  End of undefines to turn off .ctor/.dtor section support */
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/pa/rtems.h gcc-2.95.3/gcc/config/pa/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/pa/rtems.h	Wed Dec 16 15:11:13 1998
+++ gcc-2.95.3/gcc/config/pa/rtems.h	Fri Jun 22 10:49:58 2001
@@ -29,3 +29,6 @@
 #ifndef TARGET_MEM_FUNCTIONS
 #define TARGET_MEM_FUNCTIONS
 #endif
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/rs6000/rtems.h gcc-2.95.3/gcc/config/rs6000/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/rs6000/rtems.h	Wed Dec 16 15:12:14 1998
+++ gcc-2.95.3/gcc/config/rs6000/rtems.h	Fri Jun 22 10:49:58 2001
@@ -33,6 +33,10 @@
 #endif
 
 #undef STARTFILE_DEFAULT_SPEC
-#define STARTFILE_DEFAULT_SPEC "crt0.o%s"
+#define STARTFILE_DEFAULT_SPEC "ecrti.o%s crt0.o%s"
+  
+#undef ENDFILE_DEFAULT_SPEC
+#define ENDFILE_DEFAULT_SPEC "ecrtn.o%s"
 
-/* end of rs6000/rtems.h */
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/rtems.h gcc-2.95.3/gcc/config/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/rtems.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/rtems.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,4 @@
+/* Configuration common to all targets running RTEMS.  */
+
+/* The system headers under RTEMS are C++-aware.  */
+#define NO_IMPLICIT_EXTERN_C
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sh/rtems.h gcc-2.95.3/gcc/config/sh/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sh/rtems.h	Tue Jan 19 23:12:07 1999
+++ gcc-2.95.3/gcc/config/sh/rtems.h	Fri Jun 22 10:49:58 2001
@@ -32,4 +32,5 @@
 #define TARGET_MEM_FUNCTIONS
 #endif
 
-/* end of sh/rtems.h */
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sh/rtemself.h gcc-2.95.3/gcc/config/sh/rtemself.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sh/rtemself.h	Wed Jan 20 00:56:14 1999
+++ gcc-2.95.3/gcc/config/sh/rtemself.h	Fri Jun 22 10:49:58 2001
@@ -31,3 +31,6 @@
 #ifndef TARGET_MEM_FUNCTIONS
 #define TARGET_MEM_FUNCTIONS
 #endif
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sparc/rtems.h gcc-2.95.3/gcc/config/sparc/rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sparc/rtems.h	Wed Dec 16 15:13:20 1998
+++ gcc-2.95.3/gcc/config/sparc/rtems.h	Fri Jun 22 10:49:58 2001
@@ -32,4 +32,5 @@
 #define TARGET_MEM_FUNCTIONS
 #endif
 
-/* end of sparc/rtems.h */
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sparc/rtemself.h gcc-2.95.3/gcc/config/sparc/rtemself.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sparc/rtemself.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/config/sparc/rtemself.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,36 @@
+/* Definitions for rtems targeting a SPARC using a.out.
+   Copyright (C) 1996, 1997 Free Software Foundation, Inc.
+   Contributed by Joel Sherrill (joel@OARcorp.com).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include "sparc/elf.h"
+
+/* Specify predefined symbols in preprocessor.  */
+
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES "-Dsparc -D__GCC_NEW_VARARGS__ -Drtems -D__rtems__ \
+  -Asystem(rtems) -Acpu(sparc) -Amachine(sparc)"
+
+/* Generate calls to memcpy, memcmp and memset.  */
+#ifndef TARGET_MEM_FUNCTIONS
+#define TARGET_MEM_FUNCTIONS
+#endif
+
+/* Get machine-independent configuration parameters for RTEMS.  */
+#include <rtems.h>
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sparc/sparc.h gcc-2.95.3/gcc/config/sparc/sparc.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sparc/sparc.h	Mon Jun 21 12:48:49 1999
+++ gcc-2.95.3/gcc/config/sparc/sparc.h	Fri Jun 22 10:49:58 2001
@@ -222,6 +222,7 @@
 /* Common CPP definitions used by CPP_SPEC amongst the various targets
    for handling -mcpu=xxx switches.  */
 #define CPP_CPU_SPEC "\
+%{msoft-float: -D_SOFT_FLOAT}\
 %{mcypress:} \
 %{msparclite:-D__sparclite__} \
 %{mf930:-D__sparclite__} %{mf934:-D__sparclite__} \
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sparc/t-elf gcc-2.95.3/gcc/config/sparc/t-elf
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/config/sparc/t-elf	Wed Dec 16 15:13:41 1998
+++ gcc-2.95.3/gcc/config/sparc/t-elf	Fri Jun 22 10:49:58 2001
@@ -29,6 +29,8 @@
 #MULTILIB_MATCHES = msoft-float=mno-fpu mcpu?v8=mv8
 MULTILIB_MATCHES = msoft-float=mno-fpu
 
+EXTRA_MULTILIB_PARTS = crtbegin.o crtend.o
+
 LIBGCC = stmp-multilib
 INSTALL_LIBGCC = install-multilib
 
@@ -37,3 +39,4 @@
 	$(GCC_FOR_TARGET) -c -o crti.o -x assembler $(srcdir)/config/sparc/sol2-ci.asm
 crtn.o: $(srcdir)/config/sparc/sol2-cn.asm $(GCC_PASSES)
 	$(GCC_FOR_TARGET) -c -o crtn.o -x assembler $(srcdir)/config/sparc/sol2-cn.asm
+
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/configure.in gcc-2.95.3/gcc/configure.in
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/configure.in	Thu Jan 25 08:03:02 2001
+++ gcc-2.95.3/gcc/configure.in	Fri Jun 22 14:45:31 2001
@@ -565,6 +565,13 @@
 		tm_file="${tm_file} dbxcoff.h a29k/udi.h"
 		tmake_file=a29k/t-a29kbare
 		;;
+	a29k*-*-rtems*)
+		tm_file=a29k/rtems.h
+		tmake_file="a29k/t-a29kbare t-rtems"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
+		;;
 	a29k-wrs-vxworks*)
 		tm_file="${tm_file} dbxcoff.h a29k/udi.h a29k/vx29k.h"
 		tmake_file=a29k/t-vx29k
@@ -799,6 +806,13 @@
 		tm_file=arm/ecos-elf.h
 		tmake_file=arm/t-elf
 		;; 
+	arm*-*-rtems*)
+		tm_file=arm/rtems-elf.h
+		tmake_file="arm/t-arm-elf t-rtems"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
+		;;
 	arm*-*-elf)
 		tm_file=arm/unknown-elf.h
 		tmake_file=arm/t-arm-elf
@@ -827,6 +841,14 @@
 		target_cpu_default=16		
 		use_collect2=yes
 		;;
+	c4x-*-rtems*)
+		cpu_type=c4x
+		tmake_file="c4x/t-c4x t-rtems"
+		tm_file=c4x/rtems.h
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
+		;;
  	c4x-*)
  		cpu_type=c4x
  		tmake_file=c4x/t-c4x
@@ -847,6 +869,14 @@
 # This hasn't been upgraded to GCC 2.
 #	fx80-alliant-*)			# Alliant FX/80
 #		;;
+	h8300-*-rtems*)
+		tmake_file="h8300/t-h8300 t-rtems"
+		tm_file=h8300/rtems.h
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
+		float_format=i32
+		;;
 	h8300-*-*)
 		float_format=i32
 		;;
@@ -867,7 +897,10 @@
 	hppa1.1-*-rtems*)
 		tm_file="pa/pa-pro.h ${tm_file} pa/pa-pro-end.h libgloss.h pa/rtems.h"
 		xm_file=pa/xm-papro.h
-		tmake_file=pa/t-pro
+		tmake_file="pa/t-pro t-rtems"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 	hppa1.0-*-osf*)
 		tm_file="${tm_file} pa/pa-osf.h"
@@ -1340,20 +1373,41 @@
 		xm_file=i386/xm-go32.h
 		tm_file=i386/go32-rtems.h
 		tmake_file="i386/t-go32 t-rtems"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 changequote(,)dnl
-	i[34567]86-*-rtemself*)
+	i[34567]86-*-rtems*|i[34567]86-*-rtemself*)
 changequote([,])dnl
 		cpu_type=i386
 		tm_file=i386/rtemself.h
-		tmake_file="i386/t-i386bare t-rtems"
+		extra_parts="crtbegin.o crtend.o crti.o crtn.o"
+		tmake_file="i386/t-rtems-i386 i386/t-crtstuff t-rtems"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
+		;;
+changequote(,)dnl
+	i[34567]86-*-elf*)
+changequote([,])dnl
+		cpu_type=i386
+		tm_file=i386/i386elf.h
+		extra_parts="crtbegin.o crtend.o crti.o crtn.o"
+		tmake_file="i386/t-rtems-i386 i386/t-crtstuff"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 changequote(,)dnl
-	i[34567]86-*-rtems*)
+	i[34567]86-*-rtemscoff*)
 changequote([,])dnl
 		cpu_type=i386
 		tm_file=i386/rtems.h
 		tmake_file="i386/t-i386bare t-rtems"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 changequote(,)dnl
 	i[34567]86-*-sco3.2v5*)	# 80386 running SCO Open Server 5
@@ -1674,12 +1728,13 @@
 	i960-*-coff*)
 		tm_file="${tm_file} dbxcoff.h i960/i960-coff.h libgloss.h"
 		tmake_file=i960/t-960bare
-		use_collect2=yes
 		;;
 	i960-*-rtems)
 		tmake_file="i960/t-960bare t-rtems"
 		tm_file="${tm_file} dbxcoff.h i960/rtems.h"
-		use_collect2=yes
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 	i960-*-*)			# Default i960 environment.
 		use_collect2=yes
@@ -2112,13 +2167,24 @@
 		extra_headers=math-68881.h
 		float_format=m68k
 		;;
-	m68k-*-rtems*)
+	m68k-*-rtemscoff*)
 		tmake_file="m68k/t-m68kbare t-rtems"
 		tm_file=m68k/rtems.h
 		extra_headers=math-68881.h
 		float_format=m68k
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
+		;;
+	m68k-*-rtemself*|m68k-*-rtems*)
+		tmake_file="m68k/t-m68kbare t-rtems m68k/t-crtstuff"
+		tm_file=m68k/rtemself.h
+		extra_headers=math-68881.h
+		float_format=m68k
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
-
 	m88k-dg-dgux*)
 		case $machine in
 		  m88k-dg-dguxbcs*)
@@ -2642,8 +2708,18 @@
 		tmake_file=mips/t-elf
 		;;
 	mips64orion-*-rtems*)
-		tm_file="mips/elforion.h mips/elf64.h mips/rtems64.h"
-		tmake_file="mips/t-ecoff t-rtems"
+                tm_file="mips/elforion.h mips/elf64.h mips/rtems64.h"
+		tmake_file="mips/t-elf t-rtems"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
+		;;
+	mips*-*-rtems*)
+		tm_file="mips/elf.h mips/rtems.h"
+		tmake_file="mips/t-elf t-rtems"
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 	mipstx39el-*-elf*)
 		tm_file="mips/r3900.h mips/elfl.h mips/abi64.h"
@@ -2805,6 +2881,9 @@
 		     tmake_file="rs6000/t-ppc t-rtems rs6000/t-ppccomm"
 		fi
 		extra_headers=ppc-asm.h
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 	powerpc-*-linux-gnulibc1)
 		tm_file=rs6000/linux.h
@@ -3009,11 +3088,17 @@
 		tmake_file="sh/t-sh t-rtems"
 		tm_file=sh/rtemself.h
 		float_format=sh
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 	sh-*-rtems*)
 		tmake_file="sh/t-sh t-rtems"
 		tm_file=sh/rtems.h
 		float_format=sh
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 	sh-*-*)
 		float_format=sh
@@ -3088,9 +3173,22 @@
 		tmake_file=sparc/t-sunos41
 		xmake_file=x-lynx
 		;;
-	sparc-*-rtems*)
+	sparc-*-rtems*|sparc-*-rtemself*)
+		tm_file="sparc/rtemself.h"
+		tmake_file="sparc/t-elf t-rtems"
+		extra_parts="crti.o crtn.o crtbegin.o crtend.o"
+		#float_format=i128
+		float_format=i64
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
+		;;
+	sparc-*-rtemsaout*)
 		tmake_file="sparc/t-sparcbare t-rtems"
 		tm_file=sparc/rtems.h
+	        if test x$enable_threads = xyes; then
+		   thread_file='rtems'
+	        fi
 		;;
 	sparcv9-*-solaris2*)
 		tm_file=sparc/sol2-sld-64.h
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/gthr-rtems.h gcc-2.95.3/gcc/gthr-rtems.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/gcc/gthr-rtems.h	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/gcc/gthr-rtems.h	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,99 @@
+/*
+ *
+ * RTEMS threads compatibily routines for libgcc2.
+ * by: Rosimildo da Silva( rdasilva@connecttel.com )
+ *
+ */
+
+#ifndef __gthr_rtems_h
+#define __gthr_rtems_h
+
+
+#define __GTHREADS 1
+
+#define __GTHREAD_ONCE_INIT  0
+#define __GTHREAD_MUTEX_INIT_FUNCTION  rtems_gxx_mutex_init
+
+/* avoid depedency on rtems specific headers */
+typedef void *__gthread_key_t;
+typedef int   __gthread_once_t;
+typedef void *__gthread_mutex_t;
+
+/*
+ * External functions provided by RTEMS. They are very similar to their POSIX 
+ * counterparts. A "Wrapper API" is being use to avoid dependency on any RTEMS
+ * header files.
+ */
+
+/* generic per task variables */
+extern int rtems_gxx_once (__gthread_once_t *once, void (*func) ());
+extern int rtems_gxx_key_create (__gthread_key_t *key, void (*dtor) (void *));
+extern int rtems_gxx_key_dtor (__gthread_key_t key, void *ptr);
+extern int rtems_gxx_key_delete (__gthread_key_t key);
+extern void *rtems_gxx_getspecific (__gthread_key_t key);
+extern int rtems_gxx_setspecific (__gthread_key_t key, const void *ptr);
+
+/* mutex support */
+extern void rtems_gxx_mutex_init (__gthread_mutex_t *mutex);
+extern int rtems_gxx_mutex_lock (__gthread_mutex_t *mutex);
+extern int rtems_gxx_mutex_trylock (__gthread_mutex_t *mutex);
+extern int rtems_gxx_mutex_unlock (__gthread_mutex_t *mutex);
+
+
+/* Wrapper calls */
+static inline int
+__gthread_once (__gthread_once_t *once, void (*func) ())
+{
+   return rtems_gxx_once( once, func );
+}
+
+static inline int
+__gthread_key_create (__gthread_key_t *key, void (*dtor) (void *))
+{
+  return rtems_gxx_key_create( key, dtor );
+}
+
+static inline int
+__gthread_key_dtor (__gthread_key_t key, void *ptr)
+{
+   return rtems_gxx_key_dtor(key, ptr);
+}
+
+static inline int
+__gthread_key_delete (__gthread_key_t key)
+{
+  return rtems_gxx_key_delete (key);
+}
+
+static inline void *
+__gthread_getspecific (__gthread_key_t key)
+{
+  return rtems_gxx_getspecific (key);
+}
+
+static inline int
+__gthread_setspecific (__gthread_key_t key, const void *ptr)
+{
+  return rtems_gxx_setspecific (key, ptr);
+}
+
+static inline int
+__gthread_mutex_lock (__gthread_mutex_t *mutex)
+{
+    return rtems_gxx_mutex_lock (mutex);
+}
+
+static inline int
+__gthread_mutex_trylock (__gthread_mutex_t *mutex)
+{
+    return rtems_gxx_mutex_trylock (mutex);
+}
+
+static inline int
+__gthread_mutex_unlock (__gthread_mutex_t *mutex)
+{
+    return rtems_gxx_mutex_unlock( mutex );
+}
+
+#endif /* __gthr_rtems_h */
+
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/libio/gen-params gcc-2.95.3/libio/gen-params
--- /usr1/rtems/work-tools/original/gcc-2.95.3/libio/gen-params	Tue Mar 23 17:58:21 1999
+++ gcc-2.95.3/libio/gen-params	Fri Jun 22 10:49:58 2001
@@ -378,7 +378,7 @@
 [ -z "$uint32_t" ] && uint32_t="unsigned $int32_t"
 
 cat <<!EOF!
-#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 7)
+#if !defined(_C4x) && !defined(_C3x) && (__GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 7))
 typedef          int   ${macro_prefix}int8_t __attribute__((__mode__(__QI__)));
 typedef unsigned int  ${macro_prefix}uint8_t __attribute__((__mode__(__QI__)));
 typedef          int  ${macro_prefix}int16_t __attribute__((__mode__(__HI__)));
@@ -387,15 +387,15 @@
 typedef unsigned int ${macro_prefix}uint32_t __attribute__((__mode__(__SI__)));
 typedef          int  ${macro_prefix}int64_t __attribute__((__mode__(__DI__)));
 typedef unsigned int ${macro_prefix}uint64_t __attribute__((__mode__(__DI__)));
-#if __GNUC__ > 2 || __GNUC_MINOR__ >= 8
-__extension__ typedef long long ${macro_prefix}llong;
-__extension__ typedef unsigned long long ${macro_prefix}ullong;
-#endif
 #else
 typedef  $int16_t  ${macro_prefix}int16_t;
 typedef $uint16_t ${macro_prefix}uint16_t;
 typedef  $int32_t  ${macro_prefix}int32_t;
 typedef $uint32_t ${macro_prefix}uint32_t;
+#endif
+#if __GNUC__ > 2 || __GNUC_MINOR__ >= 8
+__extension__ typedef long long ${macro_prefix}llong;
+__extension__ typedef unsigned long long ${macro_prefix}ullong;
 #endif
 
 typedef ${clock_t-int /* default */} ${macro_prefix}clock_t;
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/libobjc/ChangeLog gcc-2.95.3/libobjc/ChangeLog
--- /usr1/rtems/work-tools/original/gcc-2.95.3/libobjc/ChangeLog	Fri Mar 16 06:52:21 2001
+++ gcc-2.95.3/libobjc/ChangeLog	Fri Jun 22 10:49:39 2001
@@ -1,3 +1,7 @@
+Thu May 18 07:53:12 CDT 2000 Ralf Corsepius  <corsepiu@faw.uni-ulm.de>
+
+	* thr-rtems.c: New file added to support RTEMS threading.
+
 Fri Mar 16 12:46:19 GMT 2001 Bernd Schmidt  (bernds@redhat.com)
 
 	* gcc-2.95.3 Released.
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/libobjc/thr-rtems.c gcc-2.95.3/libobjc/thr-rtems.c
--- /usr1/rtems/work-tools/original/gcc-2.95.3/libobjc/thr-rtems.c	Wed Dec 31 18:00:00 1969
+++ gcc-2.95.3/libobjc/thr-rtems.c	Fri Jun 22 10:49:58 2001
@@ -0,0 +1,194 @@
+/* GNU Objective C Runtime Thread Implementation
+   Copyright (C) 1996, 1997 Free Software Foundation, Inc.
+   Contributed by Galen C. Hunt (gchunt@cs.rochester.edu)
+   Renamed from thr-vxworks.c to thr-rtems.c by 
+     Ralf Corsepius (corsepiu@faw.uni-ulm.de)
+     
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify it under the
+terms of the GNU General Public License as published by the Free Software
+Foundation; either version 2, or (at your option) any later version.
+
+GNU CC is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+details.
+
+You should have received a copy of the GNU General Public License along with
+GNU CC; see the file COPYING.  If not, write to the Free Software
+Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* As a special exception, if you link this library with files compiled with
+   GCC to produce an executable, this does not cause the resulting executable
+   to be covered by the GNU General Public License. This exception does not
+   however invalidate any other reasons why the executable file might be
+   covered by the GNU General Public License.  */
+
+#include <objc/thr.h>
+#include "runtime.h"
+
+/* Thread local storage for a single thread */
+static void *thread_local_storage = NULL;
+
+/* Backend initialization functions */
+
+/* Initialize the threads subsystem. */
+int
+__objc_init_thread_system(void)
+{
+  /* No thread support available */
+  return -1;
+}
+
+/* Close the threads subsystem. */
+int
+__objc_close_thread_system(void)
+{
+  /* No thread support available */
+  return -1;
+}
+
+/* Backend thread functions */
+
+/* Create a new thread of execution. */
+objc_thread_t
+__objc_thread_detach(void (*func)(void *arg), void *arg)
+{
+  /* No thread support available */
+  return NULL;
+}
+
+/* Set the current thread's priority. */
+int
+__objc_thread_set_priority(int priority)
+{
+  /* No thread support available */
+  return -1;
+}
+
+/* Return the current thread's priority. */
+int
+__objc_thread_get_priority(void)
+{
+  return OBJC_THREAD_INTERACTIVE_PRIORITY;
+}
+
+/* Yield our process time to another thread. */
+void
+__objc_thread_yield(void)
+{
+  return;
+}
+
+/* Terminate the current thread. */
+int
+__objc_thread_exit(void)
+{
+  /* No thread support available */
+  /* Should we really exit the program */
+  /* exit(&__objc_thread_exit_status); */
+  return -1;
+}
+
+/* Returns an integer value which uniquely describes a thread. */
+objc_thread_t
+__objc_thread_id(void)
+{
+  /* No thread support, use 1. */
+  return (objc_thread_t)1;
+}
+
+/* Sets the thread's local storage pointer. */
+int
+__objc_thread_set_data(void *value)
+{
+  thread_local_storage = value;
+  return 0;
+}
+
+/* Returns the thread's local storage pointer. */
+void *
+__objc_thread_get_data(void)
+{
+  return thread_local_storage;
+}
+
+/* Backend mutex functions */
+
+/* Allocate a mutex. */
+int
+__objc_mutex_allocate(objc_mutex_t mutex)
+{
+  return 0;
+}
+
+/* Deallocate a mutex. */
+int
+__objc_mutex_deallocate(objc_mutex_t mutex)
+{
+  return 0;
+}
+
+/* Grab a lock on a mutex. */
+int
+__objc_mutex_lock(objc_mutex_t mutex)
+{
+  /* There can only be one thread, so we always get the lock */
+  return 0;
+}
+
+/* Try to grab a lock on a mutex. */
+int
+__objc_mutex_trylock(objc_mutex_t mutex)
+{
+  /* There can only be one thread, so we always get the lock */
+  return 0;
+}
+
+/* Unlock the mutex */
+int
+__objc_mutex_unlock(objc_mutex_t mutex)
+{
+  return 0;
+}
+
+/* Backend condition mutex functions */
+
+/* Allocate a condition. */
+int
+__objc_condition_allocate(objc_condition_t condition)
+{
+  return 0;
+}
+
+/* Deallocate a condition. */
+int
+__objc_condition_deallocate(objc_condition_t condition)
+{
+  return 0;
+}
+
+/* Wait on the condition */
+int
+__objc_condition_wait(objc_condition_t condition, objc_mutex_t mutex)
+{
+  return 0;
+}
+
+/* Wake up all threads waiting on this condition. */
+int
+__objc_condition_broadcast(objc_condition_t condition)
+{
+  return 0;
+}
+
+/* Wake up one thread waiting on this condition. */
+int
+__objc_condition_signal(objc_condition_t condition)
+{
+  return 0;
+}
+
+/* End of File */
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/libstdc++/stl/stl_config.h gcc-2.95.3/libstdc++/stl/stl_config.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/libstdc++/stl/stl_config.h	Mon May 17 18:03:48 1999
+++ gcc-2.95.3/libstdc++/stl/stl_config.h	Fri Jun 22 10:49:58 2001
@@ -176,6 +176,9 @@
 #      endif
 #    endif
 #   endif
+#   if defined(__rtems__)
+#      define __STL_PTHREADS
+#   endif
 #   ifdef __EXCEPTIONS
 #     define __STL_USE_EXCEPTIONS
 #   endif
diff -uNr /usr1/rtems/work-tools/original/gcc-2.95.3/libstdc++/stl/stl_vector.h gcc-2.95.3/libstdc++/stl/stl_vector.h
--- /usr1/rtems/work-tools/original/gcc-2.95.3/libstdc++/stl/stl_vector.h	Wed Sep  2 12:25:13 1998
+++ gcc-2.95.3/libstdc++/stl/stl_vector.h	Fri Jun 22 10:49:58 2001
@@ -218,6 +218,25 @@
   reference operator[](size_type __n) { return *(begin() + __n); }
   const_reference operator[](size_type __n) const { return *(begin() + __n); }
 
+  // NGS 06JAN00 at throws an exception if out of range
+  const_reference at(size_type __n) const
+  {
+#       ifdef  __STL_USE_EXCEPTIONS
+    if(__n >= size())
+      throw;
+#       endif //  __STL_USE_EXCEPTIONS
+    return (*(begin() + __n));
+  }
+
+  reference at(size_type __n)
+  {
+#       ifdef  __STL_USE_EXCEPTIONS
+    if(__n >= size())
+      throw;
+#       endif //  __STL_USE_EXCEPTIONS
+    return (*(begin() + __n));
+  }
+
   explicit vector(const allocator_type& __a = allocator_type())
     : _Base(__a) {}
 
